# Refaça a classe Turma usando encapsulamento
from estudante import Estudante


class Turma:

    def __init__(self, disciplina, codigo, estudantes=None):
        self._disciplina = disciplina
        self._codigo = codigo
        if estudantes is None:
            self._lista = []
        else:
            self._lista = estudantes.copy()

    @property
    def disciplina(self):
        return self._disciplina

    @disciplina.setter
    def disciplina(self, sigla):
        self._disciplina = sigla

    @property
    def estudantes(self):
        return self._lista.copy()

    def adiciona(self, estudante):
        self._lista.append(estudante)

    def imprime_estudantes(self):
        for estudante in self._lista:
            print(estudante)

    def imprime_aprovados(self):
        for estudante in self._lista:
            if estudante.aprovado():
                print(estudante)

    def imprime_reprovados(self):
        for estudante in self._lista:
            if not estudante.aprovado():
                print(estudante)

    def __str__(self):
        s = f"{self.disciplina}{self.codigo}\n"
        for estudante in self.lista:
            s += str(estudante) + "\n"
        return s
